#ifndef _MEMTRACER_H_
#define _MEMTRACER_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

#ifdef MEMTRACE_ON
#define malloc(a) memtrace_malloc(__FILE__, __LINE__, (a))
#define memalign(a,b) memtrace_memalign(__FILE__, __LINE__, (a), (b))
#define calloc(a,b) memtrace_calloc(__FILE__, __LINE__, (a), (b))
#define realloc(a,b) memtrace_realloc(__FILE__, __LINE__, (a), (b))
#define free(a) memtrace_free(__FILE__, __LINE__, (a))
#endif

void initMemtrace(const char * file, int allow_compression);
void closeMemtrace();
void * memtrace_malloc  (const char * file, int line, size_t size );
void * memtrace_memalign(const char * file, int line, size_t blocksize, size_t bytes);
void * memtrace_calloc  (const char * file, int line, size_t num, size_t size );
void * memtrace_realloc (const char * file, int line, void * ptr, size_t size );
void   memtrace_free    (const char * file, int line, void * ptr );


#ifdef __cplusplus
}
#endif


#endif
